/* STORE - первый раздел магазина */

// Блок инициализации товара и вызова слайдер и информации
class StoreCartPreview extends React.Component {

	static contextType = ShopAppContext

	render() {

		const tab = this.context.factory.GetStoreTab('top'), data = this.context.shopData.products

		if (tab == 0 || tab == 1) {

			let cat = tab == 0 ? 1 : 0

			for (let id in data) {

				let obj = data[id]

				if (obj['type-product'] == 0 && obj['category-1'] == cat)
					return (

						<div className="cart">

							<StoreCartsSlider id={id} tab={tab} />

							<StoreCartsInfo id={id} tab={tab} />

						</div>

					)

			}

		} else if (tab == 4) {

			for (let id in data) {

				let obj = data[id]

				if ('undefined' !== typeof obj['type-product'] && obj['type-product'] == 3)
					return (
						<div className="cart">

							<StoreCartsSlider id={id} tab={tab} />

							<StoreCartsInfo id={id} tab={tab} />

						</div>
					)

			}

		} else if (tab == 5) {

			for (let id in data) {

				let obj = data[id]

				if ('undefined' !== typeof obj['type-product'] && obj['type-product'] == 4)
					return (
						<div className="cart">

							<StoreCartsSlider id={id} tab={tab} />

							<StoreCartsInfo id={id} tab={tab} />

						</div>
					)

			}

		}

		else return <AccessoriesCarts set='top' />

	}

}

// Аксессуары
class AccessoriesCarts extends React.Component {

	static contextType = ShopAppContext

	constructor(props) {

		super(props)
		this.state = { itemsPosIndex: 0, detailID: 0, displayItem: '' }

	}

	cost = price => this.context.factory.PriceHelper(price, this.context.pageData.local)

	render() {

		const tab = this.context.factory.GetStoreTab('top'), data = this.context.shopData.products

		let ids = []

		switch (this.props.set) {

			case 'top':

				const getIdsTop = cat => {

					let ids = []

					for (let id in data)
						if (data[id]['category-2'] == cat && 'undefined' === typeof data[id].parent) {
							ids.push({ id: id, order: data[id].order })
						}

					return ids

				}

				ids = getIdsTop(tab - 2)

				ids.sort((a, b) => a.order - b.order);

				return ids.map(id => {
					return (

						<div className="cart">

							<StoreCartsSlider id={id.id} tab={tab} />

							<StoreCartsInfo id={id.id} tab={tab} />

						</div>


					)

				})

			case 'bottom':

				const bottom = this.context.factory.GetStoreTab('bottom'),
					local = this.context.pageData.local,
					getIdsBottom = cat => {

						let ids = []

						for (let id in data)
							if (data[id]['type-product'] == cat && 'undefined' === typeof data[id].parent)
								ids.push({ id: id, order: data[id].order })

						return ids

					},
					prevBg = p => ({ backgroundImage: 'url(' + p + ')' }),
					more = this.context.pageData.lang.access_more,
					colorBar = ids => 'object' === typeof ids ? ids.map(id => {
						if ('object' === typeof data[id] && 'boolean' === typeof data[id].hidden && !data[id].hidden) {

							return (

								// <div style={{ backgroundImage: 'url(' + data[id].attrs['color-ico'] + ')' }} />
								<img src={data[id].attrs['color-ico']} />

							)
						} else return ''

					}) : '',
					itemsPosition = i => {

						let pos = this.state.itemsPosIndex, end = ids.length - 1, pp = {}

						if (ids.length < 3) return {};

						if (pos == 0) {

							pp = { 0: '20%', 1: '50%', 2: '80%' }
							return { left: (pp[i] || '150%') }

						}

						if (pos == (end - 1)) {

							pp[pos - 1] = '20%'
							pp[pos] = '50%'
							pp[pos + 1] = '80%'
							return { left: (pp[i] || '-50%') }

						}

						if (pos > 0 && pos < end) {

							pp[pos - 1] = '-20%'
							pp[pos] = '20%'
							pp[pos + 1] = '50%'
							pp[pos + 2] = '80%'
							return 'string' === typeof pp[i] ? { left: pp[i] } : { left: (i < pos ? '-50%' : '150%') }

						}

					},
					itemsTabletPosition = i => {

						let pos = this.state.itemsPosIndex, end = ids.length - 1, pp = {}

						if (ids.length < 3) return {};

						if (pos == 0) {

							pp = { 0: '0%', 1: '52%' }
							return { left: (pp[i] || '150%') }

						}

						if (pos == (end - 1)) {

							pp[pos - 1] = '-50%'
							pp[pos] = '0%'
							pp[pos + 1] = '52%'
							return { left: (pp[i] || '-50%') }

						}

						if (pos > 0 && pos < end) {

							pp[pos - 1] = '-50%'
							pp[pos] = '0%'
							pp[pos + 1] = '52%'
							return 'string' === typeof pp[i] ? { left: pp[i] } : { left: (i < pos ? '-50%' : '150%') }

						}

					},
					setStep = f => {

						let i = i = f ? (this.state.itemsPosIndex + 1) : (this.state.itemsPosIndex - 1)
						if (i < 0) i = 0
						if (i > ids.length - 2) i = ids.length - 2
						this.setState({ itemsPosIndex: i })

					},
					swipe = (ev, dr) => { if (ids.length > 2) setStep(dr == 'left') },
					shopRowSliderClass = () => ids.length > 2 ? 'slider-wrapper' : 'slider-wrapper slider-off',
					colorBarCount = ids => ids.length > 5 ? 'color-bar large' : 'color-bar small',
					panels = () => {

						let size, pos = this.state.itemsPosIndex, end = ids.length - 1, arrowL, arrowR

						if (ids.length > 3) { size = 'decktop' }

						else if (ids.length = 3) { size = 'tablet' }

						else { size = 'none' }

						if (pos == 0) {

							arrowL = ' off', arrowR = ' on'

						}

						if (pos > 0 && pos < end) {

							arrowL = ' on', arrowR = ' on'

						}

						if (pos == (end - 1)) {


							arrowL = ' on', arrowR = ' off'

						}

						return (
							<>
								<div className={"panel left-panel " + size} /><div className={"panel right-panel " + size} />
								<div className={"arrow-slider-switch-left arrow-slider-switch " + size + arrowL} onClick={() => setStep(false)} />
								<div className={"arrow-slider-switch-right arrow-slider-switch " + size + arrowR} onClick={() => setStep(true)} />
							</>
						)
					},
					detail = (id) => {

						$('body').addClass('hidden');

						this.setState({ detailID: id, displayItem: "none" })

					},
					closeDetail = (id) => {
						$('body').removeClass('hidden')

						this.setState({ detailID: id, displayItem: '' })

					},
					detailModal = id => this.state.detailID == id ? (

						<>

							<div className="detail-modal-dialog-bg" />

							<div className="detail-modal-dialog-wrapper">

								<div className="detail-modal-dialog" onClick={event => event.stopPropagation()}>

									<div className="close-ico-2" onClick={() => closeDetail(0)}></div>

									<div className="store-section">

										<div className="cart">

											<StoreCartsSlider id={this.state.detailID} tab='2' />

											<StoreCartsInfo id={this.state.detailID} tab='2' />

										</div>

									</div>

								</div>
							</div>
						</>

					) : '',
					contentCart = (id, img, more) => {

						let obj = data[id.id], title = obj.titles[local], price = this.cost(obj.prices, local)

						return (
							<>
								<div className="top-cart">
									<div className="previews" style={prevBg(img)} />

									<div className={colorBarCount(obj.extended)}>

										{colorBar([id.id])}
										{colorBar(obj.extended)}

									</div>

									<div className="title">

										{title}

									</div>
								</div>

								<div className="bottom-cart">


									<div className="price">

										{price}

									</div>

									<div className="more">

										{more}

										<div className="arrow-more"></div>

									</div>

								</div>

							</>
						)
					},
					prevCart = (i, id, img, more) => this.state.detailID == id.id ? '' : (

						<div style={itemsPosition(i)} className={"item decktop " + this.state.displayItem} onClick={() => detail(id.id)}>

							{contentCart(id, img, more)}

						</div >

					),
					prevTabletCart = (i, id, img, more) => this.state.detailID == id.id ? '' : (

						<div style={itemsTabletPosition(i)} className={"item tablet " + this.state.displayItem} onClick={() => detail(id.id)}>

							{contentCart(id, img, more)}

						</div >

					)

				if (tab == 2 || tab == 3 || bottom != 3) return ''

				ids = getIdsBottom((tab == 0 || tab == 4 ? 1 : 0) + 1)

				ids.sort((a, b) => a.order - b.order);

				return (

					<div className="store-accessories-slider">

						<ReactTouchEvents onSwipe={swipe}>

							<div className={shopRowSliderClass()}>
								{panels()}

								<div className="shop-row-slider">

									{ids.map((id, i) => {

										let obj = data[id.id], {url: img} = JSON.parse(obj['slider-' + local])[0]

										return (
											<>

												{prevCart(i, id, img, more)}

												{prevTabletCart(i, id, img, more)}

												{detailModal(id.id)}

											</>

										)

									})}

								</div>
							</div>

						</ ReactTouchEvents>

					</div>

				)

		}

	}

}



// Модальное окно с информацией по доставке
class DeliveryDialog extends React.Component {

	static contextType = ShopAppContext

	render() {

		const html = this.context.pageData.htmlBlocks['payment-delivery'],
			show = this.context.factory.DeliveryDialog('get') ? 'show' : '',
			close = () => { this.context.factory.DeliveryDialog(false) }

		if (show) { $('body').addClass('hidden') } else { $('body').removeClass('hidden') }


		return (
			<span>

				<div className={'delivery-modal ' + show} onClick={close} >

					<div className='delivery-modal-content'>

						{/* <div className="close-ico" onClick={close} /> */}

						<div className="shop-html__payment-delivery" dangerouslySetInnerHTML={{ __html: html }} />

					</div>

				</div>

			</span>

		)

	}

}

// Главный компонент Store
const Store = () => (

	<>

		<div className="store-section">

			<StoreTabsTop />

			<div className="shop-row">

				<StoreCartPreview />

				<ShopTabsBottom />

			</div>

			<DeliveryDialog />

		</div>

	</>

)